{$R+}
Program h; uses dos; {sozd. zagot. dl`a ATOM}
{zhelat. testir. tzh. simm. - net li neinitsializ. oper.; molek - podrobnee}
{Rekomend. po vyjasn., na kakikh korotk. kontaktakh nakh. at. H:
  chitaem fajl opis. kristalla v telo etoj prog., zatykaem vse H ->
  nakhodit kontakty; zatem po odnomu vstav. atomy H (chtoby kazhdyj raz 
  vveden byl tk. 1 at. H, a proch. - zatknuty) i razreshaem sv`azi at. H
  so vsemi blizlezhashch. atomami N, O i Cl; zatem smotrim, poluch. li
  r(AH)+r(HB) ~ r(AB). Odnako etot metod -/-> odnoznachn. rezul`t., esli
  est` neekviv. sv`azi mezhdu ekviv. atomami (napr., v strukture vida
      Cl         Cl        Cl
   N          N         N
  raspoznat`, gde nakh. at. H, etot metod ne pozvol.).
}
{Rekomend. po posadke ne opisann. at. H na H-sv`az` - na primere
  alpha-formy azelain. k-ty:
  podbiraem predely, chtoby v *.MOL popali tk. okr-sti kol`tsa O1...O2
  ISKHODNOJ molekuly (0..1, -0.2..0.2, -0.2..0.2); za tsentr mol-ly
  vybir. ne 5-j, a 10-j atom (O1); v *.MOL nakhodim nuzhnye atomy
  (O1 i O2') i stroim tochku vida al*O1+(1-al)*O2'; al ber`om naugad -
  real`no mozhet byt` i 0.7, t.e. sv`az. s O2' .
}

{$i uses_gra.pas}
{$i uses_crt.pas}
{$i subrgeom.pas}

 type s5=string[5];

 type oper=record a:matr3; tau:vect3; end; {oper. simm.: x -> Ax+tau}
 var n_oper:integer; ope:array[1..48] of oper; {operatsii tochechnoj gruppy}
 var n_centrir:integer; centrir:array[1..4] of vect3; {granetsentr. etc.}

 type atom=record r:vect3; obozn:string[5]; end;
 type molec=record nat:integer; a:array[1..30] of atom; centr:vect3; end;

 var a:bazis;

 var nmolec:integer; mo:array[1..20] of molec;

 type zapi=record
  obozn:string[5]; nr_mol:integer; nr0:byte;
  r:vect3; sv:array[1..8] of integer;
 end;
 const n_zapis_max=1500;
 var n_zapis:integer;
 type arr_zapi=array[1..n_zapis_max] of zapi;
 var zapis:^arr_zapi;
 var vnes_molec:integer; {chislo izobrazhaemykh molekul}

 type contact_=record i1,i2:integer; obo1,obo2:s5; r,x,y,z:real; end;
 const n_contact_max=40;
 var n_contact:integer; contact:array[1..n_contact_max] of contact_;

 const d_razmnozh=-0.1; {dopust. vylez. iz yach.; prikh. zad. zdes`,
   t.k. nado pered RAZMNOZH, a RAZMNOZH i dr. sluzheb. podpr. nado
   pered opis. mol.}

 var i_pont:integer; nado_otobr:boolean; {VNES podpis. z i vyv. v fajl}
 var aa,b,c,alpha,beta,gamma:real;
 var gd,gm,i,j:integer; e1:ekr; f:vect3; bb:text; s:string[10];
 var color_:integer;

 procedure dejstv_oper(var y:vect3; A:matr3; x,tau:vect3); {y:=Ax+tau}
  var i,j:integer;
 begin
  y:=tau; for i:=1 to 3 do for j:=1 to 3 do y[i]:=y[i]+A[i,j]*x[j];
 end;
 procedure dejstv_centrir(var y:vect3; x,c:vect3); var i:integer;
 begin for i:=1 to 3 do y[i]:=x[i]+c[i]; end;

 procedure xyz(r:vect3; var x,y,z:real);
 begin
  x:=r[1]*a[1][1]+r[2]*a[2][1]+r[3]*a[3][1];
  y:=r[1]*a[1][2]+r[2]*a[2][2]+r[3]*a[3][2];
  z:=r[1]*a[1][3]+r[2]*a[2][3]+r[3]*a[3][3];
 end;
(*
 procedure postr_bazis(aa,bb,cc,alpha,beta,gamma:real); var v:real;
 begin
  a[1][1]:=aa; a[1][2]:=0; a[1][3]:=0;
  a[2][1]:=bb*cos(gamma); a[2][2]:=bb*sin(gamma); a[2][3]:=0;
  {obozn. baz. vekt. a,b,c, a ikh dliny - aa,bb,cc;
   c*a=cc*aa*cos(beta), c*b=cc*bb*cos(alpha);
   a[3]=b[3]=0 -> eto s-ma 2-kh ur.s 2 nyeizv. - c[3] ukhodit;
   c[1] i c[2] - ryesh.etoj s-my}
  a[3][1]:=cc*cos(beta);
  a[3][2]:=cc*((cos(alpha)-cos(beta)*cos(gamma))/sin(gamma));
  {a c[3] nakh.iz abs(c)=cc}
  a[3][3]:=sqrt(sqr(cc)-sqr(a[3][1])-sqr(a[3][2]));
  {v:=obyom(a[1],a[2],a[3]); write('v=',v:10:4); readln;}
 end;
*)
 procedure ini_1_at_mol(var mo:molec; x,y,z:real; s:s5);
 {sozd. opis. 1-atomn. molekuly}
 begin with mo do begin
  nat:=1; initvect(a[1].r,x,y,z); a[1].obozn:=s; centr:=a[1].r;
 end; end;

 procedure vnes(rr:vect3; s:string; nr:integer);
  var x,y,z,x_,y_,z_,r2:real; ss:string[10]; j,prosm:integer; gut:boolean;
 begin
  xyz(rr,x,y,z);
  {writeln('vnes: rr,s,nr=',rr[1]:10:6,rr[2]:10:6,rr[3]:10:6,' ',s:2,' ',nr:5);}
  po(x,y,e1,getmaxcolor-color_);
  if nado_otobr then begin
   gut:=true; prosm:=8;
   while gut and (prosm<n_zapis) do begin prosm:=prosm+1;
    xyz(zapis^[prosm].r,x_,y_,z_); r2:=sqrt(sqr(x-x_)+sqr(y-y_)+sqr(z-z_));
    gut:=r2>0.5;
    if (r2<=0.5) and (r2>0.0001) then begin
     writeln('Vnes: podozr. rasst.: r=',r2:10:4);
     writeln('vnosim. at.:       ',rr[1]:10:4,rr[2]:10:4,rr[3]:10:4,' ',s);
     with zapis^[prosm] do writeln('sravn. s at. Nr',prosm:4,
       r[1]:10:4,r[2]:10:4,r[3]:10:4,' ',obozn);
     readln;
    end;
   end;
   if n_zapis=n_zapis_max then begin
    writeln('Massiv ZAPIS perepoln.'); readln; n_zapis:=n_zapis+1;
   end;
   if gut and (n_zapis<n_zapis_max) then begin
    {MoveTo(po_ix,po_iy); str(z:4:2,ss); outtext(ss);}
    n_zapis:=n_zapis+1; with zapis^[n_zapis] do begin
     obozn:=s; nr_mol:=vnes_molec; nr0:=nr; r:=rr; for j:=1 to 8 do sv[j]:=0;
     {writeln(n_zapis:5,obozn:5,r[1]:10:4,r[2]:10:4,r[3]:10:4);}
    end;
   end {if gut};
  end {if nado_otobr};
 end;

 function uslov(s1,s2:s5; r:real):boolean; forward;

 function nado_sv(i,j:integer; r:real):boolean; forward;


 function iz_razn(i,j:integer):boolean; {atomy prinadl. razn. molekulam}
 begin iz_razn:=zapis^[i].nr_mol<>zapis^[j].nr_mol; end;

 function  nado_postr(q:vect3):boolean; forward;

 procedure razmnozh(var mo:molec; nr:integer);
  var ii,i,j,i1,i2,i3:integer; x,y,z,q:vect3; s:string[5]; nado:boolean;
 begin
  for i1:=-2 to 2 do begin for i2:=-2 to 2 do begin for i3:=-2 to 2 do begin
  {for i1:=0 to 0 do begin for i2:=0 to 0 do begin for i3:=0 to 0 do begin}
  for j:=1 to n_centrir do begin
  for i:=1 to n_oper do begin
   {sound(nota(i1+i2+i3+i+j));}
   x:=mo.centr;
   dejstv_oper(y,ope[i].a,x,ope[i].tau);
   dejstv_centrir(z,y,centrir[j]);
   q[1]:=z[1]+i1; q[2]:=z[2]+i2; q[3]:=z[3]+i3;
   nado:=nado_postr(q);
   {if ((i1=0) and (i2=0) and (i3=0)) or (nado and (abs(z[3]-1/3)<0.1)) then
     writeln(i1:5,i2:5,i3:5,i:5,j:5,z[1]:10:4,z[2]:10:4,z[3]:10:4,nado:6);}
   if nado then begin
   vnes_molec:=vnes_molec+1;
   {zamech.: vnes_molec narashch. vsegda, a vnes mozhet obnar., chto
     molekula v etom polozh. uzhe est`; => nomera molekul idut ne podr`ad!}
   for ii:=1 to mo.nat do begin
    x:=mo.a[ii].r; s:=mo.a[ii].obozn;
    dejstv_oper(y,ope[i].a,x,ope[i].tau);
    dejstv_centrir(z,y,centrir[j]);
    q[1]:=z[1]+i1; q[2]:=z[2]+i2; q[3]:=z[3]+i3;
    vnes(q,s,nr);
    {write(i1:5,i2:5,i3:5,j:5,i:5,ii:5,n_zapis:5,chr($0D));}
    {delay(100);}
   end; {ii}
   end; {if}
   nosound;
  end; {i}
  end; {j}
  end; end; end; {i1,i2,i3}
 end;

 procedure razmnozh_(i_mo:integer; var mo__:molec; nr:integer);
 {zamysel: izobr. dann. mol. i vse, sv`az. s nej H-sv.;
   i_mo - nomer molekuly sredi opisanij neekviv. molekul (mo[i]);
   porozhd. tekushch. molekuly i sm., sv`az. li oni s iskhodnoj mo[i]
   H-sv`az`ami; da - vnosim vse atomy, net - ne vnos. ni odin.
  Rekomendatsija: narashchivat` razmer v NADO_POSTR i sledit`,
   chtoby kazhd. sv`az` pojavilas` 2 raza - ot at. X k at Y i ot Y k X.
 }
  var ii,i,j,i1,i2,i3,jj:integer; x,y,z,q:vect3; s:string[5];
  var nado1,nado2,nado2a,nado2b:boolean;
  var r,x__,y__,z__,x_,y_,z_:real;
  var mo_:molec;
  label end_i;
 begin
  for i1:=-2 to 2 do begin for i2:=-2 to 2 do begin for i3:=-2 to 2 do begin
  {for i1:=0 to 0 do begin for i2:=0 to 0 do begin for i3:=0 to 0 do begin}
  for j:=1 to n_centrir do begin
  for i:=1 to n_oper do begin
   {sound(nota(i1+i2+i3+i+j));}
   mo_:=mo__;
   x:=mo_.centr;
   dejstv_oper(y,ope[i].a,x,ope[i].tau);
   dejstv_centrir(z,y,centrir[j]);
   q[1]:=z[1]+i1; q[2]:=z[2]+i2; q[3]:=z[3]+i3;
   nado1:=nado_postr(q);
   {if ((i1=0) and (i2=0) and (i3=0)) or (nado and (abs(z[3]-1/3)<0.1)) then
     writeln(i1:5,i2:5,i3:5,i:5,j:5,z[1]:10:4,z[2]:10:4,z[3]:10:4,nado:6);}
   if not nado1 then goto end_i;
   {if nado1 then begin}
   for ii:=1 to mo_.nat do begin
    x:=mo_.a[ii].r;
    dejstv_oper(y,ope[i].a,x,ope[i].tau);
    dejstv_centrir(z,y,centrir[j]);
    q[1]:=z[1]+i1; q[2]:=z[2]+i2; q[3]:=z[3]+i3;
    mo_.a[ii].r:=q;
   end; {ii}
   nado2:=false; for jj:=1 to mo[i_mo].nat do for ii:=1 to mo_.nat do begin
    with zapis^[n_zapis+1] do begin obozn:=mo[i_mo].a[jj].obozn; nr_mol:=1; end;
    with zapis^[n_zapis+2] do begin obozn:=mo_.a[ii].obozn; nr_mol:=2; end;
    xyz(mo[i_mo].a[jj].r,x__,y__,z__);
    xyz(mo_.a[ii].r,x_,y_,z_); r:=sqrt(sqr(x__-x_)+sqr(y__-y_)+sqr(z__-z_));
    nado2a:=r=0;
    nado2b:=nado_sv(n_zapis+1,n_zapis+2,r);
    nado2:=nado2 or nado2a or nado2b;
    if not ((i1=0) and (i2=0) and (i3=0) and (j=1) and (i=1)) and nado2b
      then writeln(i1:5,i2:5,i3:5,j:5,i:5,r:10:4,
      mo[i_mo].a[jj].obozn:5,mo_.a[ii].obozn:5,nado2b:6);
   end;
   if not nado2 then goto end_i;
   vnes_molec:=vnes_molec+1;
   {zamech.: vnes_molec narashch. vsegda, a vnes mozhet obnar., chto
     molekula v etom polozh. uzhe est`; => nomera molekul idut ne podr`ad!}
   mo_:=mo__;
   for ii:=1 to mo_.nat do begin
    x:=mo_.a[ii].r; s:=mo_.a[ii].obozn;
    dejstv_oper(y,ope[i].a,x,ope[i].tau);
    dejstv_centrir(z,y,centrir[j]);
    q[1]:=z[1]+i1; q[2]:=z[2]+i2; q[3]:=z[3]+i3;
    vnes(q,s,nr);
    {write(i1:5,i2:5,i3:5,j:5,i:5,ii:5,n_zapis:5,chr($0D));}
    {delay(100);}
   end; {ii}
   {end;} {if}
   nosound;
end_i:
  end; {i}
  end; {j}
  end; end; end; {i1,i2,i3}
 end;

 procedure izobr_yach; var s:string[10];
 begin
 nado_otobr:=false; s:='';
 for i:=0 to 100 do begin initvect(f,i/100,0,0); vnes(f,s,0); end;
 for i:=0 to 100 do begin initvect(f,i/100,1,0); vnes(f,s,0); end;
 for i:=0 to 100 do begin initvect(f,i/100,0,1); vnes(f,s,0); end;
 for i:=0 to 100 do begin initvect(f,i/100,1,1); vnes(f,s,0); end;
 for i:=0 to 100 do begin initvect(f,0,i/100,0); vnes(f,s,0); end;
 for i:=0 to 100 do begin initvect(f,1,i/100,0); vnes(f,s,0); end;
 for i:=0 to 100 do begin initvect(f,0,i/100,1); vnes(f,s,0); end;
 for i:=0 to 100 do begin initvect(f,1,i/100,1); vnes(f,s,0); end;
 for i:=0 to 100 do begin initvect(f,0,0,i/100); vnes(f,s,0); end;
 for i:=0 to 100 do begin initvect(f,1,0,i/100); vnes(f,s,0); end;
 for i:=0 to 100 do begin initvect(f,0,1,i/100); vnes(f,s,0); end;
 for i:=0 to 100 do begin initvect(f,1,1,i/100); vnes(f,s,0); end;
 end;

 procedure init_zapis_i(nr:integer; x,y,z:real; i,j,k,l,m,n:integer);
 begin
  with zapis^[nr] do begin
   obozn:='  ';
   r[1]:=x; r[2]:=y; r[3]:=z;
   sv[1]:=i; sv[2]:=j; sv[3]:=k; sv[4]:=l; sv[5]:=m; sv[6]:=n;
   sv[7]:=0; sv[8]:=0;
  end;
 end;
 procedure init_1_8;
 begin
   init_zapis_i(1, 0,0,0, 2,4,5,0,0,0);
   init_zapis_i(2, 0,1,0, 1,3,6,0,0,0);
   init_zapis_i(3, 1,1,0, 2,4,7,0,0,0);
   init_zapis_i(4, 1,0,0, 1,3,8,0,0,0);
   init_zapis_i(5, 0,0,1, 1,6,8,0,0,0);
   init_zapis_i(6, 0,1,1, 2,5,7,0,0,0);
   init_zapis_i(7, 1,1,1, 3,6,8,0,0,0);
   init_zapis_i(8, 1,0,1, 4,5,7,0,0,0);
 end;

 procedure vyv(imya:string);
  var bb:text; i,j:integer;
 begin
  assign(bb,imya); rewrite(bb);
  for i:=1 to 39 do write(bb,' ');
  writeln(bb,aa:8:4,b:8:4,c:8:4);
  for i:=1 to 22 do write(bb,' ');
  writeln(bb,alpha*180/pi:8:3,' ',beta*180/pi:8:3,' ',gamma*180/pi:8:3);
  writeln(bb,n_zapis:4); writeln(bb);
  for i:=1 to n_zapis do with zapis^[i] do begin
   write(bb,i:4,' ',copy(obozn,1,2),' ');
   for j:=1 to 3 do write(bb,r[j]:10:5);
   for j:=1 to 6 do write(bb,sv[j]:4);
   writeln(bb);
  end;
  close(bb);
 end;

 procedure prost_sv;
  var i,j,k:integer; x,y,z,x_,y_,z_,r:real;
 begin
  for i:=9 to n_zapis do begin xyz(zapis^[i].r,x,y,z);
  for j:=i+1 to n_zapis do begin xyz(zapis^[j].r,x_,y_,z_);
   {sound(10*(i+j));}
   {write(i:5,j:5,'   ',chr($0D));}
   r:=sqrt(sqr(x-x_)+sqr(y-y_)+sqr(z-z_));
   if nado_sv(i,j,r) then begin
    k:=0; repeat k:=k+1 until (k=9) or (zapis^[i].sv[k]=0);
    if k<9 then zapis^[i].sv[k]:=j else writeln(i:5,j:5,r:10:4,' >8 sv`azej.');
    k:=0; repeat k:=k+1 until (k=9) or (zapis^[j].sv[k]=0);
    if k<9 then zapis^[j].sv[k]:=i else writeln(j:5,i:5,r:10:4,' >8 sv`azej.');
   end;
   nosound;
  end end;
 end;

 function tipy(i,j:integer; a1,a2:s5):boolean; var s1,s2:s5;
 begin
  if (length(a1)<>2) or (length(a2)<>2) then begin
   writeln('tipy - l<>2.'); halt;
  end;
  s1:=copy(zapis^[i].obozn,1,2); s2:=copy(zapis^[j].obozn,1,2);
  tipy:=((s1=a1) and (s2=a2)) or ((s1=a2) and (s2=a1));
 end;

 function com(s1,s2,p1,p2:s5):boolean;
 begin com:=((s1=p1) and (s2=p2)) or ((s1=p2) and (s2=p1)); end;

 procedure zapomn_r(i,j:integer; rr:real);
  var x_,y_,z_:real; gut:boolean; prosm:integer;
 begin
  x_:=(zapis^[i].r[1]+zapis^[j].r[1])/2;
  y_:=(zapis^[i].r[2]+zapis^[j].r[2])/2;
  z_:=(zapis^[i].r[3]+zapis^[j].r[3])/2;
  {if (x_>=0) and (x_<1) and (y_>=0) and (y_<1) and (z_>=0) and (z_<1)
    then}
    {etu proverku zatykaem: alpha- i alpha1-formy erukov. k-ty: esli
    vz`at` vse molekuly c koord. x,y,z at. C iz COOH, prinadl. -0.2..1.2,
    poluch.: molekuly zigzagoobr., i serediny tsepej VSEKH etikh molek.
    vylaz`at iz jach.}
    begin
   gut:=true; prosm:=0;
   while gut and (prosm<n_contact) and (prosm<n_contact_max) do begin
    prosm:=prosm+1;
    gut:=not(
     com(zapis^[i].obozn,zapis^[j].obozn,contact[prosm].obo1,contact[prosm].obo2)
     and
     (abs((contact[prosm].r-rr)/rr)<0.0001)
    );
   end;
   if n_contact=n_contact_max then begin
    writeln('Massiv CONTACT perepoln.'); readln; n_contact:=n_contact+1;
   end;
   if gut and (n_contact<n_contact_max) then begin
    n_contact:=n_contact+1; with contact[n_contact] do begin
     i1:=i; i2:=j;
     obo1:=zapis^[i].obozn; obo2:=zapis^[j].obozn; r:=rr; x:=x_; y:=y_; z:=z_;
     writeln(n_contact:5,i:5,j:5,zapis^[i].nr_mol:5,zapis^[j].nr_mol:5,
       zapis^[i].nr0:3,zapis^[j].nr0:3,
       ' ',obo1:5,' ',obo2:5,' ',r:8:4,x:8:4,y:8:4,z:8:4);
    end;
   end {if gut};
  end;
 end;

 var mozhno_vylez:boolean;

 function vylez(x,x0,x1:real):boolean; begin vylez:=(x<x0) or (x>x1); end;

 procedure test_molec; var i_mo,j,k:integer; b1,b2:boolean;
 begin
  for i_mo:=1 to nmolec do with mo[i_mo] do begin
   for j:=1 to nat do begin
    b1:=vylez(a[j].r[1],-0.6,1.6)
      or vylez(a[j].r[2],-0.6,1.6)
      or vylez(a[j].r[3],-0.6,1.6);
    if mozhno_vylez then b1:=false; {dl`a alpha1-formy erukov. k-ty}
    if b1 then writeln(j:5,'-j atom daleko vylez. iz jach.');
    b2:=(length(a[j].obozn)<2) or (length(a[j].obozn)>5);
    write(i_mo:5,j:5,a[j].obozn:5);
    for k:=1 to 3 do write(a[j].r[k]:10:3); writeln;
    if b2 then writeln(j,'-j atom: podozrit. obozn.');
    if b1 or b2 then begin write('Test_molec: osh.'); readln; halt; end;
   end;
   b1:=vylez(centr[1],-0.6,1.6)
     or vylez(centr[2],-0.6,1.6)
     or vylez(centr[3],-0.6,1.6);
   if b1 then begin write('Test_molec: centr vylazit.'); halt; end;
  end;
 end;

 function svya(i,j:integer):boolean; var k:integer;
 begin
  k:=0; repeat k:=k+1 until (k>8) or (zapis^[i].sv[k]=j);
  svya:=k<=8;
 end;

 procedure istin_molec(imolec,i_,j_:integer);
 {pust` zatabulir. koord. atomov otnos. k ekviv., no razn. molek.;
  obrashch.: istin_molec(imolec,1,1..nat) - vyjasn., kak nado
  izmen. koord. atomov, sv`az. s 1-m, chtoby oni prinadl. toj zhe molek.;
  vnosim izmen.; zatem v kach-ve 1-go atoma pary - kakoj-libo iz tekh,
  prinadl-st` k-rykh toj zhe molek. uzhe ustanovl.; povt., poka vse ne
  budut prinadl. odnoj mol-le.
 }
  var i1,i2,i3,i,j:integer; x,y,z,q:vect3; s:s5;
  var x1,y1,z1,x2,y2,z2,r_:real;
  label ende;
 begin
  with mo[imolec] do begin
  xyz(a[i_].r,x1,y1,z1);
  for i1:=-1 to 1 do begin for i2:=-1 to 1 do begin for i3:=-1 to 1 do begin
  for j:=1 to n_centrir do begin
  for i:=1 to n_oper do begin
   x:=a[j_].r;
   dejstv_oper(y,ope[i].a,x,ope[i].tau);
   dejstv_centrir(z,y,centrir[j]);
   q[1]:=z[1]+i1; q[2]:=z[2]+i2; q[3]:=z[3]+i3;
   xyz(q,x2,y2,z2);
   r_:=sqrt(sqr(x1-x2)+sqr(y1-y2)+sqr(z1-z2));
   writeln(i1:4,i2:4,i3:4,j:4,i:4,r_:10:4);
   if (r_<1.95) then goto ende;
  end; {i}
  end; {j}
  end; end; end; {i1,i2,i3}
 ende:
  for i:=1 to 3 do write(a[i_].r[i]:10:4); writeln;
  for i:=1 to 3 do write(x[i]:10:4); writeln;
  for i:=1 to 3 do write(q[i]:10:4); writeln;
  end;
 end;

 function tipy_(s1,s2,e1,e2:s5):boolean;
 begin
  tipy_:=
   ((copy(s1,1,2)=e1) and (copy(s2,1,2)=e2))
    or
   ((copy(s1,1,2)=e2) and (copy(s2,1,2)=e1));
 end;

{ ------------------------------ }
{$i symmetry.pas}
{$i p_khinon.inc}
{ $i khio32.add}
{ ------------------------------ }

Begin
 new(zapis);
 init_crt;
 initgraph_12;
 prisv_ekr(e1,0.0,1.0,0.0,1.0,-10,30,-10,30,-10,30,-10,30);

 init_1_8;

 mozhno_vylez:=false;
 writeln(imya); zad_bazis;
 zad_simm; {show_simm; readln;}
 zad_molec; test_molec;

 {istin_molec(1,1,2); readln; halt;}

 nado_otobr:=false; color_:=0; izobr_yach;

 nado_otobr:=true; n_zapis:=8; {1..8 - vershiny jachejki} vnes_molec:=0;
 for i:=1 to nmolec do begin
  color_:=i; if color_>15 then color_:=15;
  razmnozh(mo[i],i); {izobr. vsej strukt.}
  {razmnozh_(1,mo[i],i);} {izobr. molek., sv`az. H-sv`az`ami s 1 molek. sorta 1}
 end;

 n_contact:=0;
 prost_sv;
 vyv(imya+'.mol');
 {dopoln_anal;}

 readln; closegraph;
 dispose(zapis);
End.
