{p-C6H4O2; Acta Cryst. 1960, 13(2), 86}

 const imya='p_khinon';

 procedure zad_bazis; var grad:real;
 begin
  grad:=pi/180;
  aa:=7.055; b:=6.795; c:=5.765;
  alpha:=90*grad; beta:=(101+28/60)*grad; gamma:=90*grad;
  postr_bazis(aa,b,c,alpha,beta,gamma,a);
 end;

 procedure zad_simm; begin P2_1_a; end;

 procedure zad_molec; var i:integer;
 begin
  nmolec:=1;
  with mo[1] do begin
   nat:=6;
   initvect(a[1].r,0.1069,-0.0272,0.2334); a[1].obozn:='C A';
   initvect(a[2].r,0.0638,0.1703,0.1341); a[2].obozn:='C B'; {sv`az. s O}
   initvect(a[3].r,-0.0459,0.1848,-0.1095); a[3].obozn:='C C';
   initvect(a[4].r,0.1182,0.3168,0.2502); a[4].obozn:='O D';
   initvect(a[5].r,0.1868,-0.0459,0.4094); a[5].obozn:='H A';
   initvect(a[6].r,-0.0812,0.3270,-0.1929); a[6].obozn:='H B';
   centr:=a[2].r;
  end;
 end;

 function uslov(s1,s2:s5; r:real):boolean; var g1,g2:boolean;
 begin
  {g1:=tipy_(s1,s2,'Ti','O ') and (r<2.4);}
  {g2:=tipy_(s1,s2,'O ','O ') and (r<3.0);}
  uslov:={g1}false;
 end;

 function nado_sv(i,j:integer; r:real):boolean; var g1,g2:boolean;
  function not_H(s:s5):boolean; begin not_H:=copy(s,1,2)<>'H '; end;
 begin
  g1:=(r<1.1) or
    ((r<1.65) and not_H(zapis^[i].obozn) and not_H(zapis^[j].obozn));
  {g2:=iz_razn(i,j) and uslov(zapis^[i].obozn,zapis^[j].obozn,r);}
  if g1 {or g2} then zapomn_r(i,j,r);
  nado_sv:=g1 {or g2};
 end;

 function nado_postr;
 {opisana: function nado_postr(q:vect):boolean; forward;}
  var d:real;
 begin
  d:=0.2;
  nado_postr:=(q[1]>=-d) and (q[1]<=(1+d))
    and (q[2]>=-d) and (q[2]<=(1+d))
    and (q[3]>=-d) and (q[3]<=(1+d));
 end;

